﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <deque>
using namespace std;
vector<int> used;
deque<int> dd;
vector<int> ans;
/*
int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b,a%b);
}
*/
void bfs(vector<vector<int>> g, int s, int d) {
    used[s] = 0;
    dd.push_back(s);
    while (!dd.empty()) {
        int y = dd.back();
        dd.pop_back();
        for (auto i : g[y]) {
            if (used[i]==-1) {
                dd.push_back(i);
                used[i] = used[y]+1;
                if (used[i] <= d) {
                    ans[i] = 1;
                }
            }
        }
    }
}
signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, k; cin >> n >> m >> k;
    used.resize(n + 1,-1);
    ans.resize(n + 1);
    vector<vector<int>> gg(n+1);
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        gg[a].push_back(b);
        gg[b].push_back(a);
    }
    for (int i = 0; i < k; i++) {
        int a, b; cin >> a >> b;
        ans[a] = 1;
        bfs(gg, a, b);
        //used.clear();
        //used.resize(n + 1,-1);
    }
    int ss = 0;
    for (int i = 1; i <= n; i++) {
        if (ans[i] == 1) {
            ss++;
        }
    }
    if (ss > 0) {
        cout << ss << '\n';
        for (int i = 1; i <= n; i++) {
            if (ans[i] == 1) {
                cout << i << ' ';
            }
        }
    }
}