﻿#include <iostream>
#include <vector>
#include <math.h>
#include <algorithm>
#include <string>
#include <deque>
#include <set>
using namespace std;
vector<int> used;
deque<int> dd;
vector<pair<int,int>> pom;
/*
int gcd(int a, int b) {
    if (b == 0) {
        return a;
    }
    return gcd(b,a%b);
}
*/
void bfs(vector<vector<int>> g, int s) {
    used[s] = 0;
    dd.push_back(s);
    while (!dd.empty()) {
        int y = dd.back();
        dd.pop_back();
        for (auto i : g[y]) {
            if (used[i]==-1) {   
                used[i] = used[y]+1;
                dd.push_back(i);
            }
        }
    }
}
signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n, m, k; cin >> n >> m >> k;
    used.resize(n + 1,-1);
    pom.resize(k);
    vector<vector<int>> gg(n+1);
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b;
        gg[a].push_back(b);
        gg[b].push_back(a);
    }
    for (int i = 0; i < k; i++) {
        int a, b; cin >> a >> b;
        pom[i] = { a,b };
    }
    bfs(gg, 1);
    vector<int> ans;
    for (int i = 1; i <= n; i++) {
        int l = 0, r = k - 1;
        while (l+1 < r) {
            int m = (l + r) / 2;
            if (pom[m].first > i) { r = m; }
            else { l = m; }
        }
        if (abs(used[pom[l].first] - used[i]) <= pom[l].second || abs(used[pom[r].first] - used[i]) <= pom[r].second) {
            ans.push_back(i);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
}